Package org.silverpeas.components.suggestionbox.model

## Interface SuggestionBoxService

- All Superinterfaces:
    `org.silverpeas.core.ApplicationService`
  All Known Implementing Classes:
    `DefaultSuggestionBoxService`

      public interface SuggestionBoxService
      extends org.silverpeas.core.ApplicationService

  A business service to provide a high level interface in the management of the suggestion boxes and of the suggestions.

  This service isn't intended to be used as such but within the business objects SuggestionBox and Suggestion. All the operations requiring interaction with other business services or persistence repositories are delegated to this service by the SuggestionBox objects and by the Suggestion objects.

  Author:
    mmoquillon

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `deleteSuggestionBox​(SuggestionBox box)` | Deletes the specified suggestion box.
    `static SuggestionBoxService` | `get()` | Gets an object of this interface.
    `SuggestionBox` | `getByComponentInstanceId​(String componentInstanceId)` |
    `Optional<Suggestion>` | `getContributionById​(org.silverpeas.core.contribution.model.ContributionIdentifier contributionId)` |
    `void` | `indexSuggestionBox​(SuggestionBox suggestionBox)` | Indexes all the validated suggestions of the specified suggestion box.
    `void` | `saveSuggestionBox​(SuggestionBox box)` | Saves the specified suggestion box.

    - ### Methods inherited from interface org.silverpeas.core.ApplicationService

      `getComponentMessages, getComponentSettings, isRelatedTo`

- - ### Method Detail

    - #### get

          static SuggestionBoxService get()

      Gets an object of this interface. The default implementation is used.
      Returns:
        a SuggestionBoxService object.

    - #### getContributionById

          Optional<Suggestion> getContributionById​(org.silverpeas.core.contribution.model.ContributionIdentifier contributionId)

      Specified by:
        `getContributionById` in interface `org.silverpeas.core.ApplicationService`

    - #### getByComponentInstanceId

          SuggestionBox getByComponentInstanceId​(String componentInstanceId)

      Parameters:
        `componentInstanceId` - the identifier of a suggestion box instance.
      Returns:
        the suggestion box belonging to the specified component instance.
      See Also:
        `(String)`

    - #### indexSuggestionBox

          void indexSuggestionBox​(SuggestionBox suggestionBox)

      Indexes all the validated suggestions of the specified suggestion box.
      Parameters:
        `suggestionBox` - the suggestion box on which the indexation is performed.

    - #### saveSuggestionBox

          void saveSuggestionBox​(SuggestionBox box)

      Saves the specified suggestion box.
      Parameters:
        `box` - the box to save in Silverpeas.

    - #### deleteSuggestionBox

          void deleteSuggestionBox​(SuggestionBox box)

      Deletes the specified suggestion box.
      Parameters:
        `box` - the box to delete from Silverpeas.